<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: io/readmesh.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_7dc76e12c3f74bb85b7effb3b7dc07e4.html">io</a>
  </div>
</div>
<div class="contents">
<h1>readmesh.c</h1><a href="readmesh_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: readmesh.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="magpario_8h.html">magpario.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="readmesh_8c.html#a365fc802eafb717ba4c584655d1e9b64">00029</a> <span class="keywordtype">int</span> <a class="code" href="magpario_8h.html#a365fc802eafb717ba4c584655d1e9b64">ReadMesh</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   PetscTruth flg;
<a name="l00034"></a>00034   ierr = PetscOptionsGetString(PETSC_NULL,<span class="stringliteral">&quot;-simName&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>,255,&amp;flg);CHKERRQ(ierr);
<a name="l00035"></a>00035   <span class="keywordflow">if</span> (flg!=PETSC_TRUE)
<a name="l00036"></a>00036     SETERRQ(PETSC_ERR_ARG_CORRUPT,<span class="stringliteral">&quot;Option -simName not found!\n&quot;</span>);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordtype">int</span> meshtype;
<a name="l00039"></a>00039   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-meshtype&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;meshtype,&amp;flg);CHKERRQ(ierr);
<a name="l00040"></a>00040   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00041"></a>00041     meshtype=1;
<a name="l00042"></a>00042     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00043"></a>00043       <span class="stringliteral">&quot;Option -meshtype not found, using default value: %i\n&quot;</span>,
<a name="l00044"></a>00044       meshtype
<a name="l00045"></a>00045     );
<a name="l00046"></a>00046   }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   ierr = PetscOptionsGetInt(PETSC_NULL,<span class="stringliteral">&quot;-inp&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,&amp;flg);CHKERRQ(ierr);
<a name="l00049"></a>00049   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00050"></a>00050     gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>=1;
<a name="l00051"></a>00051     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00052"></a>00052       <span class="stringliteral">&quot;Option -inp not found, using default value: %i\n&quot;</span>,
<a name="l00053"></a>00053       gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>
<a name="l00054"></a>00054     );
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056   ierr = MPI_Bcast(&amp;gdata-&gt;<a class="code" href="structGridData.html#a4cc9b420611ac5eed22ee3bb2533fde4">inp</a>,1,MPIU_SCALAR,0,PETSC_COMM_WORLD);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">/* indicate, that we have no FE mesh yet */</span>
<a name="l00059"></a>00059   gdata-&gt;<a class="code" href="structGridData.html#a1adbd5611aad877423d82c0ae9aae5ad">vertxyz</a>=NULL;
<a name="l00060"></a>00060   gdata-&gt;<a class="code" href="structGridData.html#a8622e85fd1e5cf0dedd8960cc80f2e5c">elevert</a>=NULL;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (meshtype==0){
<a name="l00063"></a>00063     ierr = <a class="code" href="magpario_8h.html#a4e53aaaa9226ca0805f1f006e8bda38a">ReadPatran</a>(gdata);CHKERRQ(ierr);
<a name="l00064"></a>00064   }
<a name="l00065"></a>00065   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (meshtype==1){
<a name="l00066"></a>00066     <span class="comment">/* TODO: read filename directly from option */</span>
<a name="l00067"></a>00067     <span class="keywordtype">char</span> fmesh[256];
<a name="l00068"></a>00068     ierr = PetscSNPrintf(fmesh,255,<span class="stringliteral">&quot;%s.inp&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a2fba16fa768b0451df8fd12ed00a6c6b">simname</a>);CHKERRQ(ierr);
<a name="l00069"></a>00069     ierr = <a class="code" href="magpario_8h.html#ac48e244b5ec28e4a0d8a7ce8596bbe76">ReadINP</a>(gdata,fmesh,PETSC_NULL,0);CHKERRQ(ierr);
<a name="l00070"></a>00070   }
<a name="l00071"></a>00071   <span class="keywordflow">else</span> {
<a name="l00072"></a>00072     SETERRQ(PETSC_ERR_ARG_OUTOFRANGE,<span class="stringliteral">&quot;-meshtype has illegal value!\n&quot;</span>);
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

